package app;

import model.Population;
import model.SetupEvolutionDTO;

import java.util.Random;

/**
 * Created with IntelliJ IDEA.
 * User: lukas
 * Date: 13.5.15
 */
public interface EvolutionAPI {

    Random randomGenerator = new Random();

    /**
     * Tahle metoda se musi pustit prvni. Slouzi k vytvořeni první populace.
     * Vytvori se nahodny jedinci
     * @param setupProcess prepravka, kde jsou parametry k evoluci
     */
    Population createInitialPopulation(SetupEvolutionDTO setupProcess);

    /**
     * Metoda vytvori z predesle populace novou populaci. Provede selekci, krizeni, mutaci
     * @param previousPopulation
     * @return nova LEPSI populace
     */
    Population createNextPopulation(Population previousPopulation);
}
