package service.impl.crossover;

import model.Individual;
import service.api.CrossoverService;
import utils.EvolutionUtils;
import app.EvolutionAPI;

/**
 * Created with IntelliJ IDEA.
 * User: lukas
 * Date: 13.4.15
 */
public class OnePointCrossover implements CrossoverService {
    @Override
    public Individual[] crossover(Individual parent1, Individual parent2) {
        //parent's chromosomes
        String parentChromosome1 = parent1.getChromosome();
        String parentChromosome2 = parent2.getChromosome();

        int length = parentChromosome1.length();
        //get random point crossover
        Integer crossoverPoint = EvolutionAPI.randomGenerator.nextInt(length);

        String childChromosome1;
        String childChromosome2;

        //create child's chromosomes
        if (Math.random() < 0.5) {
            childChromosome1 = parentChromosome1.substring(0, crossoverPoint) + parentChromosome2.substring(crossoverPoint, length);
            childChromosome2 = parentChromosome2.substring(0, crossoverPoint) + parentChromosome1.substring(crossoverPoint, length);
        } else {
            childChromosome1 = parentChromosome2.substring(0, crossoverPoint) + parentChromosome1.substring(crossoverPoint, length);
            childChromosome2 = parentChromosome1.substring(0, crossoverPoint) + parentChromosome2.substring(crossoverPoint, length);
        }

        //create offspring
        Individual child1 = EvolutionUtils.createIndividual(childChromosome1);
        Individual child2 = EvolutionUtils.createIndividual(childChromosome2);

        return new Individual[]{child1, child2};
    }
}
