package service.impl.selection;

import model.Individual;
import service.api.SelectionService;
import utils.QualityComparator;

import java.util.List;

public class RouletteSelection implements SelectionService {

    @Override
    public Individual randomSelectIndividual(List<Individual> individuals, double sumOfFitnessFunction) {
        double sum = sumOfFitnessFunction;
        individuals.sort(new QualityComparator());

        double fitnessPoint = Math.random() * sumOfFitnessFunction;

        for (Individual individual : individuals) {
            Double currentQuality = individual.getQuality();
            sum -= currentQuality;
            //for last the worst individual set end of range as "0"
            if (currentQuality.equals(0d)) {
                sum = 0;
            }

            if (sum < fitnessPoint) {
                return individual;
            }
        }
        return null;
    }
}
