package service.impl.selection;

import app.EvolutionAPI;
import model.Individual;
import service.api.SelectionService;
import utils.QualityComparator;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Implementace Selekce jako TURNAJE
 */
public class TournamentSelection implements SelectionService {

    @Override
    public Individual randomSelectIndividual(List<Individual> individuals, double sumOfFitnessFunction) {

        int numberOfCompetitors = EvolutionAPI.randomGenerator.nextInt(8) + 2;

        List<Individual> competitors = new ArrayList<>(numberOfCompetitors);
        for (int i = 1; i <= numberOfCompetitors; i++) {
            int randomIndex = EvolutionAPI.randomGenerator.nextInt(individuals.size() - 1);

            competitors.add(individuals.get(randomIndex));
        }

        Collections.sort(competitors, new QualityComparator());
        return competitors.get(0);
    }
}
